open Dbml

let query_file = "athlete.sql";;
let db_name="db3";;
let table = "result_table";;
let node = "********";;
let user = "********";;
let passwd = "******";;

let rec get_all_tuples c =
    let t=dbml_has_next c in
    print_string (t ^ "\n");
    if (String.length t)<> 0 then
      get_all_tuples c;
;;

let liste_tuples entete liste =
  print_string ("\n" ^ entete ^ "\n");
  List.iter (Printf.printf "%s\n") liste;
;;


let query_test () =
  (*let table=dbml_exec query_file db_name "4" in*)
  let curs=dbml_open_node_cursor table node user passwd
  in 
  begin
  let entetes=dbml_entetes curs in
  print_string(entetes ^ "\n");
  get_all_tuples curs;
  dbml_close curs;
 end;
;;

try
  query_test()
with      Failure s -> prerr_string s
        | Sys_error s -> prerr_string s;;
