
%{

#include<string.h>
#include "calc.h"

int lineno=1;
int i, lng;

%}

%%

[\t]+  ;
AND                           {return AND;}
MIN                           {return MIN;}
MAX                           {return MAX;}
SUM                           {return SUM;}
COUNT                         {return COUNT;} 
AVG                           {return AVG;}
BY                            {return BY;}
CLOSE                         {return CLOSE;}
FROM                          {return FROM;}
GROUP                         {return GROUP;}
HAVING                        {return HAVING;}
IN                            {return IN;}
MACHINE                       {return MACHINE;}
NOT                           {return NOT;}
NULLX                         {return NULLX;}
OR                            {return OR;}
ORDER                         {return ORDER;}
PRIMARY                       {return PRIMARY;}
KEY                           {return KEY;}
[Ss][Ee][Ll][Ee][Cc][Tt]      {return SELECT;}
UNIQUE                        {return UNIQUE;}
UNPDATE                       {return UNPDATE;}
[Ww][Hh][Ee][Rr][Ee]          {return WHERE;}
ALL                           {return ALL;}
DISTINCT                      {return DISTINCT;}
[Cc][Rr][Ee][Aa][Tt][Ee]      {return CREATE;}
[Tt][Aa][Bb][Ll][Ee]          {return TABLE;}
CHARACTER                     {return CHARACTER;}
NUMERIC                       {return NUMERIC;}
DECIMAL                       {return DECIMAL;}
INTEGER                       {return INTEGER;}
SMALLINT                      {return SMALLINT;}
FLOAT                         {return FLOAT;}
REAL                          {return REAL;}
DOUBLE                        {return DOUBLE;}
PRECISION                     {return PRECISION;}
DEFAULT                       {return DEFAULT;}
USER                          {return USER;}
REFERENCES                    {return REFERENCES;}
CHECK                         {return CHECK;}
FOREIGN                       {return FOREIGN;}
[Aa][Ss]                      {return AS;}
[Uu][Ss][Ii][Nn][Gg]          {return USING;}
[Oo][Nn]                      {return ON;}




"="   {return EGAL;}
"<>"  {return DIFF;}
"<"   {return INF;}
">"   {return SUP;}
"<="  {return INFEGAL;}
">="  {return SUPEGAL;}


[-+*/:(),.;]  { return *yytext;}

['\"] {return QUOTE;}

[\n]+ ;

 

[A-Za-z][A-Za-z0-9_]*   { 
                          strcpy(yylval.rach, yytext);
                          /*printf("yytext=%s\n", yytext);*/
                          /*printf("yylval=%s\n", yylval.rach);*/
                         
                          return NAME;}


                          
   <<EOF>>              {return EOFFF;} 


 [0-9]*  { 
                          strcpy(yylval.rach, yytext);
                          /*printf("yytext=%s\n", yytext);*/
                          /*printf("yylval=%s\n", yylval.rach);*/
                         
                          return INTNUM;}
