
%{

#include <math.h> 
#include <stdlib.h> 
#include <string.h>
#include "parser.h"
#include "calcfunc.h"
#include "infostables.h"

extern FILE *yyin ,*yyout;
FILE *coucou;


char select_att[100]; /* pour retourner les parametres de la selection*/
char from_att[100]; /*pour retourner les parametres de FROM*/
int type_op;
char where_att[1000];
int where_exist; /*test si ya un where***/
int where_cond; /*test si il ya une ou plusieurs expressions */
char machine_att[100];
char machine_u_att[1000]; // parametres lors de l'utilisation d'un using
char machine_o_att[1000]; // parametres lors de l'utilisation d'un on

//int type; /****determine le type de where, utilis par la fonction alloue_sql *****/
//list_sql2 *ptr, *tete, *pt , *pt1;
query_list* tete;
struct attribut *atts;

// est ce le meilleur endroit ?
 info_tables* it;//=getInfoTables(NULL); pour l'instant dans parser
%}
%union {

char rach[1000];
} 

%token QUOTE
%token <rach>ALL
%token <rach>MIN           
%token <rach>MAX           
%token <rach>SUM 
%token <rach>COUNT          
%token <rach>AVG  
%token <rach>AND
%token <rach>BY
%token CLOSE
%token <rach>CREATE 
%token <rach>DISTINCT
%token <rach>FROM 
%token <rach>GROUP
%token <rach>HAVING
%token IN 
%token <rach>MACHINE
%token <rach>NOT
%token <rach>OR
%token <rach>ORDER
%token <rach>SELECT 
%token UNPDATE 
%token <rach>TABLE
%token <rach>WHERE
%token <rach>NAME
%token <rach>EGAL
%token <rach>DIFF
%token <rach>INF
%token <rach>SUP
%token <rach>INFEGAL
%token <rach>SUPEGAL
%token <rach>EOFFF
%token <rach>CHARACTER
%token <rach>INTNUM 
%token <rach>NUMERIC 
%token <rach>DECIMAL 
%token <rach>INTEGER 
%token <rach>FLOAT 
%token <rach>REAL 
%token <rach>DOUBLE 
%token <rach>SMALLINT 
%token <rach>PRECISION 
%token <rach>NULLX
%token <rach>UNIQUE
%token <rach>PRIMARY
%token <rach>KEY
%token <rach>USER
%token <rach>DEFAULT
%token <rach>REFERENCES 
%token <rach>CHECK  
%token <rach>FOREIGN
%token <rach>ON
%token <rach>USING
%token <rach>AS

%left OR
%left AND
%left NOT  
%left '+' '-'
%left  '*' '/'
%left NEG 
%nonassoc UMINUS
%type <rach>sql
%type <rach>sql_list
%type <rach>manipulative_statement
%type <rach>select_statement
%type <rach>opt_all_distinct
%type <rach>selection
%type <rach>from_clause
%type <rach>table_ref_commalist
%type <rach>table_ref 
%type <rach>range_variable
%type <rach>table
%type <rach>table_exp
%type <rach>machine_clause
%type <rach>machine_using
%type <rach>machine_on
%type <rach>where_clause
%type <rach>group_by_clause
%type <rach>having_by_clause
%type <rach>order_by_clause
%type <rach>scalar_exp_commalist 
%type <rach>scalar_exp 
%type <rach>search_condition 
%type <rach>predicate
%type <rach>column_ref
%type <rach>function_ref
%type <rach>ammsc
%type <rach>comparaison_predicate
%type <rach>comparaison
%type <rach>ligne
%type <rach>mach
%type <rach>mach_on
%type <rach>mach_using
%type <rach>schema
%type <rach>table_element_commalist
%type <rach>table_element
%type <rach>column_def
%type <rach>data_type
%type <rach>column_def_opt_list
%type <rach>column_def_opt
%type <rach>table_contraint_def
%type <rach>column_commalist
%type <rach>as_clause
%type <rach>on_clause
%type <rach>using_clause


%start input
%%

input:
|input ligne  {   /*printf("oooooooooooooooooo\n");*/
               return 0;}
;

ligne:
EOFFF
|sql_list  EOFFF
;

sql_list :  
sql ';'  {
  tete=ajout_req(tete,select_att,from_att,where_att,machine_att,&where_exist,nom_fich,$1,coucou,type_op,it);
}
|sql_list  sql ';' { 
  tete=ajout_req(tete,select_att,from_att,where_att,machine_att,&where_exist,nom_fich,$2,coucou,type_op,it);
} 
;

sql:
manipulative_statement {  strcpy($$,$1); type_op=0; } /* requete */
|schema      {printf("create\n"); strcpy($$,$1); type_op=1} /* creation d'une table */
;

schema :
/************************************************************************/
/* creation d'une nouvelle table avec precision des types des attributs */
/************************************************************************/
/* aspect de cette requete de creation :                                */
/*                                                                      */
/* CREATE TABLE nom_table (liste_des_attributs_type)                    */
/* MACHINE: liste_machines                                              */
/************************************************************************/
CREATE TABLE table '(' table_element_commalist ')' machine_clause {strcpy($$,"CREATE TABLE ");
                                                                   strcat($$,$3);
                                                                   strcat($$," (");
                                                                   strcat($$,$5);
                                                                   strcat($$,")\n");
								   strcat($$,$7);
                                                                  }
/***************************************************************/
/* creation d'une nouvelle table a partir de tables existantes */
/***************************************************************/
/* aspect de cette requete de creation :                       */
/*                                                             */
/* CREATE TABLE nom_table (liste_des_attributs)                */
/* [ON (liste_de_machines)]                        optionnel   */
/* AS SELECT ...                                               */
/* FROM ...                                                    */
/* WHERE ...                                                   */
/* [USING (liste_de_machines)]                     optionnel   */
/***************************************************************/
/* Note : il faut detailler les 4 cas (avec ou sans option)    */
/***************************************************************/

/* pas ON et pas USING */
|CREATE TABLE table '(' column_commalist ')' as_clause {printf("machines : rien\n");
                                                        strcpy($$,"CREATE TABLE ");
                                                        strcat($$,$3);
						        strcat($$," (");
							strcat($$,$5);   // liste des attributs
							strcat($$,")\n");
							strcat($$,$7);   // AS...
							}
/* ON et pas USING */
|CREATE TABLE table '(' column_commalist ')' on_clause as_clause {printf("machines : ON\n");
                                                                  strcpy($$,"CREATE TABLE ");
                                                                  strcat($$,$3);
								  strcat($$," (");
								  strcat($$,$5);    // liste des attributs
								  strcat($$,")\n");
								  strcat($$,$7);    // ON...
								  strcat($$,"\n");
								  strcat($$,$8);    // AS...
                                                                 }
/* pas ON et USING */
|CREATE TABLE table '(' column_commalist ')' as_clause using_clause {printf("machines : USING\n");
                                                                     strcpy($$,"CREATE TABLE ");
                                                                     strcat($$,$3);
								     strcat($$," (");
								     strcat($$,$5);    // liste des attributs
								     strcat($$,")\n");
								     strcat($$,$7);    // AS...
								     strcat($$,"\n");
								     strcat($$,$8);    // USING...
								     }
/* ON et USING */
|CREATE TABLE table '(' column_commalist ')' on_clause as_clause using_clause {printf("machines : ON et USING\n");
                                                                               strcpy($$,"CREATE TABLE ");
                                                                               strcat($$,$3);
									       strcat($$," (");
									       strcat($$,$5);    // liste des attributs
									       strcat($$,")\n");
									       strcat($$,$7);    // ON...
									       strcat($$,"\n");
									       strcat($$,$8);    // AS...
									       strcat($$,"\n");
									       strcat($$,$9);    // USING...
                                                                              }
;

/*****************************/
/* clause as                 */
/*****************************/
/* aspect :                  */
/*                           */
/* AS SELECT liste_attributs */
/* FROM liste_tables         */
/* WHERE liste_condition     */
/*****************************/
as_clause :
AS select_statement {strcpy($$,"AS ");strcat($$,$2);}
;

/********************************/
/* clause on                    */
/********************************/
/* aspect :                     */
/*                              */
/* ON (MACHINE: liste_machines) */
/********************************/
on_clause :
ON '(' machine_on ')' {strcpy($$,"ON (");strcat($$,$3);strcat($$,")");}
;

/***********************************/
/* clause using                    */
/***********************************/
/* aspect :                        */
/*                                 */
/* USING (MACHINE: liste_machines) */
/***********************************/
using_clause :
USING '(' machine_using ')' {strcpy($$,"USING (");strcat($$,$3);strcat($$,")");}
;

table_element_commalist :
table_element {strcpy($$,$1);}
|table_element_commalist ',' table_element  {strcpy($$,$1);strcat($$,",\n"); strcat($$,$3);}
;

table_element :
column_def { strcpy($$,$1);}
|table_contraint_def    { strcpy($$,$1);} 
;

table_contraint_def :
UNIQUE  { strcpy($$,"UNIQUE");}
|PRIMARY KEY '(' column_commalist ')' {strcpy($$,"PRIMARY KEY"); strcat($$,"("); strcat($$,$4); strcat($$,")");}
|FOREIGN KEY '(' column_commalist ')'  REFERENCES table {strcpy($$,"FOREIGN KEY"); strcat($$,"("); strcat($$,$4); strcat($$,") REFERENCES "); strcat($$,$7);}
|CHECK
;

/***********************************/
/* liste des attributs sans typage */
/***********************************/
/* aspect :                        */
/*                                 */
/* att1,att2...,attn               */
/***********************************/
column_commalist :
NAME  {strcpy($$,$1);}
|column_commalist ',' NAME {strcpy($$,$1); strcat($$,","); strcat($$,$3);}
;

column_def :
NAME data_type { strcpy($$,$1); strcat($$," "); strcat($$,$2);}
|NAME data_type column_def_opt_list { strcpy($$,$1); strcat($$," "); strcat($$,$2);strcat($$," ");strcat($$,$3);}
;
column_def_opt_list :
column_def_opt   {strcpy($$,$1);}
|column_def_opt_list column_def_opt  {strcpy($$,$1); strcat($$," ");strcat ($$,$2);}
;
column_def_opt :
 NOT NULLX {strcpy($$,"NOT NULLX");}
|NOT NULLX UNIQUE  {strcpy($$,"NOT NULLX UNIQUE");}
|NOT NULLX PRIMARY KEY  {strcpy($$,"NOT NULLX PRIMARY KEY");}
|DEFAULT NULLX  {strcpy($$,"DEFAULT NULLX");}
|DEFAULT USER   {strcpy($$,"DEFAULT USER");}
|DEFAULT INTNUM   {strcpy($$,"DEFAULT "); strcat($$,$2);}
|REFERENCES table  {strcpy($$,"REFERENCES "); strcat($$,$2);}
;

data_type :
CHARACTER {strcpy($$,"CHARACTER");}
|CHARACTER '(' INTNUM ')' {strcpy($$,"CHARACTER"); strcat($$,"("); strcat($$,$3); strcat($$,")");}
|NUMERIC   {strcpy($$,"NUMERIC");}
|NUMERIC '(' INTNUM ')'   {strcpy($$,"NUMERIC"); strcat($$,"("); strcat($$,$3); strcat($$,")");}
|NUMERIC '(' INTNUM  ',' INTNUM ')'   {strcpy($$,"NUMERIC"); strcat($$,"("); strcat($$,$3); strcat($$,","); strcat($$,$5); strcat($$,")");}
|DECIMAL   {strcpy($$,"DECIMAL");}
|DECIMAL '(' INTNUM ')'   {strcpy($$,"DECIMAL"); strcat($$,"("); strcat($$,$3); strcat($$,")");}
|DECIMAL '(' INTNUM  ',' INTNUM ')'  {strcpy($$,"DECIMAL"); strcat($$,"("); strcat($$,$3); strcat($$,","); strcat($$,$5); strcat($$,")");}
|INTEGER    {strcpy($$,"INTEGER ");}
|SMALLINT   {strcpy($$,"SMALLINT");}
|FLOAT      {strcpy($$,"FLOAT");}
|FLOAT '(' INTNUM ')'   {strcpy($$,"FLOAT"); strcat($$,"("); strcat($$,$3); strcat($$,")");}
|REAL        {strcpy($$,"REAL");}
|DOUBLE PRECISION    {strcpy($$,"DOUBLE PRECISION"); }
;

manipulative_statement : 
   select_statement {strcpy($$,$1);}
   ;
   
select_statement : 
  SELECT opt_all_distinct  selection  from_clause table_exp {
    printf("select\n");
    strcpy($$, "SELECT ");
    strcat($$, $2); strcat($$, $3); strcat($$, $4);strcat($$, $5); 
    /************************/
    strcpy(select_att,$3);
  }
 |SELECT  selection  from_clause    table_exp  {
    strcpy($$, "SELECT "); strcat($$, $2); strcat($$, $3);strcat($$, $4); 
    /*******************************/
    strcpy(select_att,$2);
  }
 ;

opt_all_distinct :
 ALL {strcpy($$, "ALL ");}
 | DISTINCT {strcpy($$, "DISTINCT ");}
 ;

selection:
 scalar_exp_commalist   {strcpy($$, $1);}
|'*'  { strcpy($$, "*"); }
;


from_clause :
FROM  table_ref_commalist {strcpy($$, "\nFROM ");  strcat($$, $2);
                           strcpy(from_att, $2);}
;

table_ref_commalist :
 table_ref{strcpy($$, $1);}
|table_ref_commalist ',' table_ref {strcpy($$, $1);strcat($$, ","); strcat($$, $3);}
;

table_ref :
table {strcpy($$, $1);}
|table range_variable {strcpy($$, $1);strcat($$, $2);}
;

table :
NAME {strcpy($$, $1);}
|NAME '.' NAME {strcpy($$, $1); strcat($$, "."); strcat($$, $3);}
;

range_variable :
NAME {strcpy($$, " ");strcat($$, $1);}
;

table_exp:
machine_clause {strcpy($$, $1); }
|where_clause machine_clause {strcpy($$, $1); }
|group_by_clause machine_clause {strcpy($$, $1); }
|having_by_clause machine_clause {strcpy($$, $1); }
|order_by_clause machine_clause {strcpy($$, $1); }
|where_clause group_by_clause machine_clause {strcpy($$, $1); strcat($$, $2); }
|where_clause having_by_clause machine_clause {strcpy($$, $1); strcat($$, $2);  }
|where_clause order_by_clause machine_clause {strcpy($$, $1); strcat($$, $2);  }
|group_by_clause having_by_clause machine_clause {strcpy($$, $1); strcat($$, $2);  }
|group_by_clause order_by_clause machine_clause {strcpy($$, $1); strcat($$, $2);  }
|having_by_clause order_by_clause machine_clause {strcpy($$, $1); strcat($$, $2);  }
|where_clause group_by_clause having_by_clause machine_clause {strcpy($$, $1); strcat($$, $2); strcat($$, $3); }
|where_clause group_by_clause order_by_clause machine_clause {strcpy($$, $1); strcat($$, $2); strcat($$, $3); }
|group_by_clause having_by_clause order_by_clause machine_clause {strcpy($$, $1); strcat($$, $2); strcat($$, $3);  }
|where_clause group_by_clause having_by_clause order_by_clause machine_clause {strcpy($$, $1); strcat($$, $2); strcat($$, $3); strcat($$, $4);}
;

/***************************/
/* clause machine          */
/***************************/
/* aspect :                */
/*                         */
/* MACHINE: liste_machines */
/***************************/
machine_clause:
MACHINE ':' mach {strcpy($$,"");
                  strcpy(machine_att, $3);
                 }
;

/************************/
/* liste de machines    */
/************************/
/* aspect :             */
/*                      */
/* mach1,mach2...,machn */
/************************/
mach:
NAME  {strcpy($$,$1);}
|mach ',' NAME {strcpy($$,$1);
                strcat($$,",");
                strcat($$,$3);
               }
;

/***************************/
/* clause machine on       */
/***************************/
/* aspect :                */
/*                         */
/* MACHINE: liste_machines */
/***************************/
machine_on:
MACHINE ':' mach_on {strcpy($$,"");
                  strcpy(machine_o_att, $3);
                 }
;

/************************/
/* liste de machines on */
/************************/
/* aspect :             */
/*                      */
/* mach1,mach2...,machn */
/************************/
mach_on:
NAME  {strcpy($$,$1);}
|mach_on ',' NAME {strcpy($$,$1);
                strcat($$,",");
                strcat($$,$3);
               }
;

/***************************/
/* clause machine using    */
/***************************/
/* aspect :                */
/*                         */
/* MACHINE: liste_machines */
/***************************/
machine_using:
MACHINE ':' mach_using {strcpy($$,"");
                  strcpy(machine_u_att, $3);
                 }
;

/****************************/
/* liste de machines using  */
/****************************/
/* aspect :                 */
/*                          */
/* mach1,mach2...,machn     */
/****************************/
mach_using:
NAME  {strcpy($$,$1);}
|mach_using ',' NAME {strcpy($$,$1);
                strcat($$,",");
                strcat($$,$3);
               }
;

where_clause:
WHERE search_condition {strcpy($$, "\n WHERE "); strcat($$, $2);
                        where_cond=0;
                        where_exist=1;}
;

group_by_clause :
GROUP BY NAME {strcpy($$, "\n GROUP BY "); strcat($$, $3);}
;

having_by_clause :
HAVING BY NAME {strcpy($$, "\n HAVING BY "); strcat($$, $3); }
;

order_by_clause :
ORDER BY NAME {strcpy($$, "\n ORDER BY "); strcat($$, $3); }
;

search_condition :
 search_condition OR search_condition {strcpy($$,$1);strcat($$," OR ");strcat($$,$3);
                                       strcat(where_att, "2");}
|search_condition AND search_condition {strcpy($$,$1);strcat($$," AND ");strcat($$,$3);
                                        strcat(where_att, "1");}
| NOT search_condition  {strcpy($$," NOT "); strcat($$,$1); }
|'('search_condition ')' {strcpy($$,"("); strcat($$,$2); strcat($$,")");}
| predicate  {strcpy($$,$1);}
;

predicate :
comparaison_predicate {strcpy($$,$1);}
;

comparaison_predicate :
scalar_exp comparaison scalar_exp {// printf("cas 1\n");
 strcpy($$,$1);strcat($$, $2);strcat($$,$3);
                                   if (where_cond==0 ){
                                   
                                   strcpy(where_att, "[");
                                   where_cond=1;}
                                   
                                   else
                                   {strcat(where_att, "[");}
                                   strcat(where_att, "1,"); strcat(where_att,$2);
                                   strcat(where_att, ",");strcat(where_att,$1);strcat(where_att, ",");
                                   strcat(where_att,$3);strcat(where_att,"]");}

|scalar_exp comparaison QUOTE NAME QUOTE {
                                  //printf("cas 2\n");
                                  strcpy($$,$1);strcat($$, $2);strcat($$,$4);
                                   if (where_cond==0 ){
                                     strcpy(where_att, "[");
                                     where_cond=1;
				   } else {
				     strcat(where_att, "[");
				   }
                                   strcat(where_att, "2,"); strcat(where_att,$2);
                                   strcat(where_att, ",");strcat(where_att,$1);strcat(where_att, ",");
                                   strcat(where_att,$4);strcat(where_att,"]");}

|scalar_exp comparaison INTNUM { //printf("cas 3\n");
                                   strcpy($$,$1);strcat($$, $2);strcat($$,$3);
                                   if (where_cond==0 ){
				     strcpy(where_att, "[");
				     where_cond=1;
				   } else {
				     strcat(where_att, "[");
				   }
                                   strcat(where_att, "2,"); strcat(where_att,$2);
                                   strcat(where_att, ",");strcat(where_att,$1);strcat(where_att, ",");
                                   strcat(where_att,$3);strcat(where_att,"]");}

;

comparaison:
EGAL  {strcpy($$,"="); }
|DIFF  {strcpy($$,"<>"); }
|INF  {strcpy($$,"<"); }
|SUP  {strcpy($$,">"); }
|INFEGAL  {strcpy($$,"<="); }
|SUPEGAL  {strcpy($$,">="); }
;



scalar_exp_commalist :
scalar_exp { strcpy($$,$1);}
|scalar_exp_commalist ',' scalar_exp {strcpy($$,$1);strcat($$,",");strcat($$,$3); }
;

scalar_exp :

 scalar_exp '+' scalar_exp {strcpy($$,$1);strcat($$,"+");strcat($$,$3); }
|scalar_exp '-' scalar_exp {strcpy($$,$1);strcat($$,"-");strcat($$,$3); }
|scalar_exp '*' scalar_exp {strcpy($$,$1);strcat($$,"*");strcat($$,$3); }
|scalar_exp '/' scalar_exp {strcpy($$,$1);strcat($$,"/");strcat($$,$3); }
| '+' scalar_exp %prec UMINUS {strcpy($$,"+");strcat($$,$2);}
| '-' scalar_exp %prec UMINUS {strcpy($$,"-");strcat($$,$2);}
| '(' scalar_exp  ')' {strcpy($$,"(");strcat($$,$2);strcat($$,")");} 
|column_ref {strcpy($$,$1);} 
|function_ref {strcpy($$,$1);}
;

function_ref :
 ammsc '(' '*' ')' {strcpy($$,$1);strcat($$,"(");strcat($$,"*");strcat($$,")");} 
|ammsc '(' DISTINCT column_ref ')' {strcpy($$,$1);strcat($$,"(");strcat($$,"DISTINCT ");strcat($$,$4);strcat($$,")");}
|ammsc  '(' ALL scalar_exp ')'{strcpy($$,$1);strcat($$,"(");strcat($$,"ALL ");strcat($$,$4);strcat($$,")");}
|ammsc  '('  scalar_exp ')' {strcpy($$,$1);strcat($$,"(");strcat($$,$3);strcat($$,")");} 
; 

ammsc :
MIN  {strcpy($$,"MIN ");}
| MAX {strcpy($$,"MAX ");}
| SUM {strcpy($$,"SUM ");}
| COUNT {strcpy($$,"COUNT ");}          
| AVG {strcpy($$,"AVG ");}
;

column_ref :
NAME {strcpy($$,$1);} 
|NAME '.' NAME {strcpy($$,$1);strcat($$,".");strcat($$,$3);} 
| NAME '.' NAME '.' NAME {strcpy($$,$1);strcat($$,".");strcat($$,$3);strcat($$,".");strcat($$,$5);} 
;






%%
int yyerror (char *s){ fprintf(stderr, "%s\n",s); }


