#ifndef TREECONSTH

#define LOPJOIN 1
#define LOPSELECT 2

struct _list_op {  
  char *table1;    /* 1ere table de la jointure */
  char *table2;    /* 2eme table de la jointure */
  char *at1;       /* attribut joint de la 1ere table */
  char *at2;       /* attribut joint de la 2eme table */
  int type_op;  
  char *op_join;   /* operateur de jointure (=,>,etc.) */
};

typedef struct _list_op list_op;

struct _list_attr {  
  char *table;    /* table projection */
  char *at;    /* attr projection */
};

typedef struct _list_attr list_attr;


void attrEtTable(char* chaine,char** attr,char** table);
int getNbNoeuds(char* where);
int getOperations(char* wherestr,list_op** whereop);
void printOperations(list_op* lop,int nbop);
void freeOperations(list_op** lop,int nbop);
int getNbAtt(char* str);
int getAttributes(char* selectstr,list_attr** selectl);
void printAttributes(list_attr* lat,int nbat);
void freeAttributes(list_attr** lat,int nbat);

#define TREECONSTH
#endif
