#include "subsite.h"

// pourrait etre remplace par un memcpy
void copietab(int *t1,int r1,int *t2,int r2,int nb) {
     int i;
     int j;
     for (i=r1,j=r2;i<nb;i++,j++) {
	 t2[j]=t1[i];
     }
}


// fusion de deux tableaux avec suppression des doublons
int merge(int nb1,int *nodes1,int nb2,int *nodes2,int** nodes) {
  int *nn=(int*)malloc(sizeof(int)*(nb1+nb2));		// la liste merge
  int nbn=0;						// le nombre de noeuds mergs
  int cpt1=0;
  int cpt2=0;
  int newval;
  //init : premier element dans la liste
  if ((nb1>0)&&(nb2>0)) {
    if (nodes1[cpt1]<nodes2[cpt2]) {
      nn[0]=nodes1[cpt1];
      cpt1++;
    } else {
      nn[0]=nodes2[cpt2];
      cpt2++;
    }
    nbn++;
  }
  while ((cpt1<nb1)&&(cpt2<nb2)) {
    if (nodes1[cpt1]<nodes2[cpt2]) {
      newval=nodes1[cpt1];
      cpt1++;
    } else {
      newval=nodes2[cpt2];
      cpt2++; 
    }
    if (nn[nbn-1]!=newval) {
      nn[nbn]=newval;
      nbn++;
    }  
  }
  if (cpt1!=nb1) {
    copietab(nodes1,cpt1,nn,nbn,nb1);
  } else if (cpt2!=nb2) {
    copietab(nodes2,cpt2,nn,nbn,nb2);
  }
(*nodes)=(int*)realloc(nn,sizeof(int)*nbn);
return nbn;
}



// recherche un element dans un tableau ordonn. pourrait tre amlior par dychotomie...
int intab(int val,int *tab,int n) {
int i=0;
//printf("dans subsite %d %d\n",val,n);
//printf("id %d i %d n %d tab[i] %d\n",val, i, n, tab[i]);

while ((i<n)&&(val>tab[i])){
  i++;
}
return ((i<n)&&(val==tab[i]));
}

// Retourne 1 si le noeud est destinataire, 0 sinon
int isDest(int id,comms* c) {
  return (intab(id,c->nodesD,c->nbnodesD));
}






// production des comms. retourne 1 si noeud concern, 0 sinon.
int getComms(list_sql2 *op,comms* c,int id) {
  MPI_Group grworld;
  //int *taball;
  MPI_Group groups;
  int typeNoeud=0;
  int worldid;
  
  // dtermine si le noeud intervient dans l'opration et  quel titre
  if (intab(id,op->nodes1,op->nbnodes1)) {
    typeNoeud+=SOURCE1;
  }
  if (intab(id,op->nodes2,op->nbnodes2)) {
    typeNoeud+=SOURCE2;
  }
  if (intab(id,op->nodesD,op->nbnodesD)) {
    typeNoeud+=DEST;
  }
  //printf("typeNoeud pour %d : %d\n",id,typeNoeud);
  
  // si le noeud intervient on renseigne les informations ncessaires (groupe MPI, listes de noeuds...) 
  //if (typeNoeud) {
    MPI_Comm_rank(MPI_COMM_WORLD,&worldid);

    c->nbnodes1=op->nbnodes1;
    c->nodes1=op->nodes1;
    c->nbnodes2=op->nbnodes2;
    c->nodes2=op->nodes2;
    c->nbnodesS=merge(c->nbnodes1,c->nodes1,c->nbnodes2,c->nodes2,&(c->nodesS));
    c->nbnodesD=op->nbnodesD;
    c->nodesD=op->nodesD;
    c->nbnodesSD=merge(c->nbnodesS,c->nodesS,c->nbnodesD,c->nodesD,&(c->nodesSD));
    
    MPI_Comm_group(MPI_COMM_WORLD,&grworld);
   
    //if (typeNoeud&(SOURCE1|SOURCE2)) {   
    //if (typeNoeud&SOURCE1) {
	MPI_Group_incl(grworld,c->nbnodes1,c->nodes1,&groups);
	MPI_Comm_create(MPI_COMM_WORLD,groups,&(c->src1));
    if (typeNoeud&SOURCE1) {
	MPI_Comm_rank(c->src1,&(c->myid1));
	}
      
    //if (typeNoeud&SOURCE2) {   
	MPI_Group_incl(grworld,c->nbnodes2,c->nodes2,&groups);
	MPI_Comm_create(MPI_COMM_WORLD,groups,&(c->src2));
	if (typeNoeud&SOURCE2) {   
	MPI_Comm_rank(c->src2,&(c->myid2));
	}

      MPI_Group_incl(grworld,c->nbnodesS,c->nodesS,&groups);
      MPI_Comm_create(MPI_COMM_WORLD,groups,&(c->src));
      if (typeNoeud&(SOURCE1|SOURCE2)) { 
	MPI_Comm_rank(c->src,&(c->myidS));
      }

      //if (typeNoeud&DEST) {
      MPI_Group_incl(grworld,c->nbnodesD,c->nodesD,&groups);
      MPI_Comm_create(MPI_COMM_WORLD,groups,&(c->dst));
      if (typeNoeud&DEST) {
	MPI_Comm_rank(c->dst,&(c->myidD));
      }

    MPI_Group_incl(grworld,c->nbnodesSD,c->nodesSD,&groups);
    MPI_Comm_create(MPI_COMM_WORLD,groups,&(c->sd));
    if (typeNoeud)
    MPI_Comm_rank(c->sd,&(c->myidSD));

    //free(taball);
    //}
  return typeNoeud;
}

