#include "histbin.h"
#include <stdlib.h>
#include <sys/time.h>

int main(int* argc,char* argv[]){
  int nbval=atoi(argv[1]);
  int delta=atoi(argv[2]);
  //int taillechaine=atoi(argv[3]);
  int taillechaine=10;
  char* chaine=(char*)malloc(taillechaine);
  int i;
  HIST hist;
  HIST hist2;
  HIST hist3;
  HIST_ARRAY* ha;
  HIST_ARRAY* hb;

  struct timeval t1,t2;
  struct timezone tz;
  int time1,time2,nbblocs1,nbblocs2;
  int nbblocs;
  HIST_ARRAY* ptr;
  //  printf("va initialiser\n");
  hist_init(&hist,8192,0,taillechaine+1,get_key,free_record);
  for (i=0;i<nbval;i++) {
    //printf("va ajouter %d\n",i);
    sprintf(chaine,"%d",i);
    hist_insert_frequency(&hist,chaine,random()%delta);
  }
  hist_init(&hist2,8192,0,taillechaine+1,get_key,free_record);
  //hist_init(&hist3,8192,0,taillechaine+1,get_key,free_record);

  gettimeofday(&t1,&tz);
  ha=HIST_to_HIST_ARRAY(&hist);
  HIST_ARRAY_to_HIST(ha,&hist2);
  gettimeofday(&t2,&tz);

  time1=(t2.tv_usec-t1.tv_usec)+1e6*(t2.tv_sec-t1.tv_sec);
  for (ptr=ha,nbblocs=0;ptr!=NULL;ptr=ptr->next,nbblocs++);
  //printf("temps : %d  blocs : %d\n",time,nbblocs);
  nbblocs1=nbblocs;
  

  gettimeofday(&t1,&tz);
  hist_array_buffer(&hist,&hb);
  hist_load_array_buffer(hb,&hist3,8192,0,taillechaine+1,get_key,free_record);
     
  //  HIST_ARRAY_to_HIST(hb,&hist3);
  gettimeofday(&t2,&tz);

  time2=(t2.tv_usec-t1.tv_usec)+1e6*(t2.tv_sec-t1.tv_sec);
  for (ptr=hb,nbblocs=0;ptr!=NULL;ptr=ptr->next,nbblocs++);
  //printf("temps : %d  blocs : %d\n",time,nbblocs);
  nbblocs2=nbblocs;

  printf("%d %d %d %d\n",time1,nbblocs1,time2,nbblocs2);
   
  

  return 1;
}
