#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "hist.h"


#define MAX_RECORDS 10000
#define MAX_KEYS 3


static int rnd(int max_value);

static uint testflag=0,recant=100,reclength=37;
static ulong key1[1000];

/* Ge ett randomv{rde inom ett intervall 0 <=x <= n */

static int rnd(int max_value)
{
  return (int) ((rand() & 32767)/32767.0*max_value);
} /* rnd */

char* get_key2(const char *key,uint *length)
{
 *length=strlen(key);
 return (char*) key;
}

char *hist2_key(const char *rec,uint *length)
{
  *length=(uint) (uchar) rec[reclength-1];
  return (char*) rec;
}






		/* Huvudprogrammet */

int main(int argc,char *argv[])
{
  register uint i,j,k;
  uint n=0,n1,n2,n3,freq, freq1=0, freq2=0;
  uint write_count,update,delete;
  ulong pos;
  unsigned long key_check;
  char *record,*record1,*recpos,oldrecord[120], entry[120],key[120],*chaine,dest[200];
  time_t debut, fin;
  HIST hist,lhist, hist2,hist3,hist4,hist5,fhist,nfhist;
  HIST_ARRAY list,*fhistlist;
  
 
  write_count=update=delete=0;
  key_check=0;
  bzero(key1,sizeof(key1[0])*1000);

  printf("- Creating hist\n");
  time(&debut);
  if (hist_init(&hist,recant,0,0,get_key,free_record))
       printf("- Creating hist Error ....\n");
  if (hist_init(&fhist,recant,0,0,get_trunc_key_double_int,free_record))
       printf("- Creating hist Error ....\n");
  
    for (i=0;i<MAX_RECORDS;i++) {
        j= rand() % (MAX_RECORDS*100); 
        sprintf(entry,"%dAA",i);
        hist_insert_frequency(&hist,entry,i);
        sprintf(entry,"%dAA %*d %*d",i,FREQ_SPACE,5,FREQ_SPACE,7);
        hist_insert_frequency(&fhist,entry,i);
    }
    i=1721; 
    sprintf(entry,"%dAA",i);
    if (chaine=(char*)hist_search_frequency(&hist, entry, strlen(entry),&freq))
	printf("\n In hist - entry :  '%s' - data :'%s' - freq: %d",entry,chaine, freq); 
    else printf("\n In hist - entry :  '%s' not found",entry);     
 
    if (chaine=(char*)hist_search_frequency(&fhist, entry, strlen(entry),&freq))
	printf("\n In fhist - entry :  '%s' - data :'%s' - freq: %d",entry,chaine, freq); 
    else printf("\n In fhist - entry :  '%s' not found",entry);     


    if (chaine=(char*)hist_search_frequency(&hist, entry, strlen(entry),&freq))
	printf("\n ## In hist - entry :  '%s' - data :'%s' - freq: %d",entry,chaine, freq); 
    else printf("\n ## In hist - entry :  '%s' not found",entry);     
 
    if (chaine=(char*)hist_search_frequency(&fhist, entry, strlen(entry),&freq)){
	 printf("\n ##  chaine :'%s'-  log chaine : %d - %d - %d ####%d", chaine,strlen(chaine),strlen(chaine)-2*FREQ_SPACE-1,strlen(chaine)-FREQ_SPACE, atoi(" 89  1")); 
        freq1=atoi(strncpy(dest,chaine+(strlen(chaine)-2*FREQ_SPACE-1),FREQ_SPACE));
        freq2=atoi(strncpy(dest,chaine+(strlen(chaine)-FREQ_SPACE),FREQ_SPACE)); 
          printf("\n ## In fhist - entry :  '%s' - data :'%s' - freq: %d - freq1: %d - freq2: %d ",entry,chaine, freq, freq1, freq2);
    } 
    else printf("\n ## In fhist - entry :  '%s' not found",entry);     

    //    strcpy (entry, "1721AA        5        8");
    //     hist_insert_frequency(&fhist,entry,1721);
    
    i=1721; 
    sprintf(entry,"%dAA",i);     
    if (chaine=(char*)hist_search_frequency(&fhist, entry, strlen(entry),&freq)){
	 printf("\n ##  chaine :'%s'-  log chaine : %d - %d - %d ####%d", chaine,strlen(chaine),strlen(chaine)-2*FREQ_SPACE-1,strlen(chaine)-FREQ_SPACE, atoi(" 89  1")); 
        freq1=atoi(strncpy(dest,chaine+(strlen(chaine)-2*FREQ_SPACE-1),FREQ_SPACE));
        freq2=atoi(strncpy(dest,chaine+(strlen(chaine)-FREQ_SPACE),FREQ_SPACE)); 
          printf("\n ## In fhist - entry :  '%s' - data :'%s' - freq: %d - freq1: %d - freq2: %d ",entry,chaine, freq, freq1, freq2);
    } 
    else printf("\n ## In fhist - entry :  '%s' not found",entry);  


    fhistlist=HIST_to_HIST_ARRAY(&fhist);
    HIST_ARRAY_to_HIST(fhistlist,&nfhist,0,0,recant,get_trunc_key_double_int,free_record);
    
    if(hist_comp_n(&hist,&nfhist)==1)
      printf("\n@@@@@@@@@@@@@@@@@@@@@@@ fhist and  nfhist are identical @@@@@@@@@\n");  
    else   printf("\n@@@@@@@@@@@@@@@@@@@@@@@ fhist and  nfhis not  identical @@@@@@@@@\n");  


    if(hist_comp_n(&fhist,&fhist)==1)
      printf("\n@@@@@@@@@@@@@@@@@@@@@@@ fhist and  nfhist are identical @@@@@@@@@\n");  
    else   printf("\n@@@@@@@@@@@@@@@@@@@@@@@ fhist and  nfhis not  identical @@@@@@@@@\n");  


    //hist_show(&hist);
    printf("\n@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\n");

    //hist_show(&fhist);
    printf("\n@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\n");
    if(hist_comp_n(&hist,&nfhist)==1)
      printf("\n@@@@@@@@@@@@@@@@@@@@@@@1 are identical @@@@@@@@@\n");
    
    if(hist_comp_n(&fhist,&fhist)==1)
      printf("\n@@@@@@@@@@@@@@@@@@@@@@@2 are identical @@@@@@@@@\n");
   


 return(0);

} /* main */


