#include <calc.h>
#include <parser.h>
#include <common.h>

typedef  char __Query[1024];
char* create_join_query(list_sql2* sql_query,int myid);

void  show_sql_queries(requetes)
query_list  *requetes ;
{
  query_list* curr_req;
  list_sql2* curr_op;
  char* qbuf;
  int myid;


 if (requetes){
   for (curr_req=requetes; curr_req!=NULL ; curr_req=curr_req->next) {  
     for (curr_op=curr_req->query;curr_op!=NULL;curr_op=curr_op->suivant1) {
       if (curr_req->nbq==1) {    
	 qbuf=create_join_query(curr_op,myid);
	 printf("-------------------------------------------\n%s\n\n-------------------------------------------\n",qbuf);
         trace_list_sql2(curr_op);
	 free(qbuf);  
       } else {
	 qbuf=create_join_query(curr_op,myid); 
	 printf("\n-------------------------------------------\n%s\n\n-------------------------------------------\n",qbuf); 
         trace_list_sql2(curr_op);
	 free(qbuf); 
       }
     }
   }
   //printf("\n#################################################################################################"); 
 } else printf("\n#################################################################################################"); 
 
}


char* create_join_query(sql_query,myid)
list_sql2  *sql_query ;
int myid;
{ __Query  qbuf, fields="", fieldname;
 int i=0;

   
   if (sql_query->nb_at1_res>0) {
     if (sql_query->al1_res==NULL) {
       sprintf(fieldname,"%s.%s ", sql_query->table1, sql_query->at1_res[0]);
     } else {
       sprintf(fieldname,"%s.%s AS %s", sql_query->table1, sql_query->at1_res[0], sql_query->al1_res[0]);
     }
     strcat(fields, fieldname); 
    
	  
     for(i=1;i<sql_query->nb_at1_res;i++) {
       if (sql_query->al1_res==NULL) {
	 sprintf(fieldname,", %s.%s ", sql_query->table1, sql_query->at1_res[i]);
       } else {
	 sprintf(fieldname,", %s.%s AS %s", sql_query->table1, sql_query->at1_res[i], sql_query->al1_res[i]);
       }
       strcat(fields, fieldname);
     }
     
     for(i=0;i<sql_query->nb_at2_res;i++) {
       if (sql_query->al2_res==NULL) {
	 sprintf(fieldname,", %s.%s ", sql_query->table2, sql_query->at2_res[i]);
       }else{
	 sprintf(fieldname,", %s.%s AS %s", sql_query->table2, sql_query->at2_res[i], sql_query->al2_res[i]);
       }
       strcat(fields, fieldname);
     }
   } else 
     {
       if (sql_query->nb_at2_res>0) {
	 if (sql_query->al2_res==NULL) {
           sprintf(fieldname,"%s.%s ", sql_query->table2, sql_query->at2_res[0]);
	 }else{
           sprintf(fieldname,"%s.%s AS %s", sql_query->table2, sql_query->at2_res[0], sql_query->al2_res[0]);
	 }
	 strcat(fields, fieldname); 
       }
	  
       for(i=1;i<sql_query->nb_at2_res;i++) {
 	 if (sql_query->al2_res==NULL) {
          sprintf(fieldname,", %s.%s ", sql_query->table2, sql_query->at2_res[i]);
	 }else{
           sprintf(fieldname,", %s.%s AS %s", sql_query->table2, sql_query->at2_res[i], sql_query->al2_res[i]);
	 }
	 strcat(fields, fieldname);
       }
     } 
   if (sql_query->tableres) {
     if (sql_query->table2!=NULL) {
       sprintf(qbuf,"Create table %s as select %s from %s,%s where %s.%s %s %s.%s",sql_query->tableres,fields,sql_query->table1,sql_query->table2,sql_query->table1,sql_query->at1,sql_query->op_join,sql_query->table2,sql_query->at2);
     } else {
       sprintf(qbuf,"Create table %s as select %s from %s where %s.%s %s %s",sql_query->tableres,fields,sql_query->table1,sql_query->table1,sql_query->at1,sql_query->op_join,sql_query->at2);
     }
   }
   else {
     if (sql_query->table2!=NULL) {
       sprintf(qbuf,"Select %s from %s,%s where %s.%s %s %s.%s",fields,sql_query->table1,sql_query->table2,sql_query->table1,sql_query->at1,sql_query->op_join,sql_query->table2,sql_query->at2);
     } else {
       sprintf(qbuf,"Select %s from %s where %s.%s %s %s",fields,sql_query->table1,sql_query->table1,sql_query->at1,sql_query->op_join,sql_query->at2);
     }
   }      
   return((char*) recopie(qbuf));
}
char*  create_join_append_query(sql_query,myid)
list_sql2  *sql_query ;
int myid;
{ __Query  qbuf, fields="", fieldname;
 int i=0;

   
   if (sql_query->nb_at1_res>0) {
       sprintf(fieldname,"%s.%s ", sql_query->table1, sql_query->at1_res[0]);
       strcat(fields, fieldname); 
    
	  
       for(i=1;i<sql_query->nb_at1_res;i++) {
           sprintf(fieldname,", %s.%s ", sql_query->table1, sql_query->at1_res[i]);
           strcat(fields, fieldname);
        }

       for(i=0;i<sql_query->nb_at2_res;i++) {
          sprintf(fieldname,", %s.%s ", sql_query->table2, sql_query->at2_res[i]);
          strcat(fields, fieldname);
       }
   } else 
     {
       if (sql_query->nb_at2_res>0) {
           sprintf(fieldname,"%s.%s ", sql_query->table2, sql_query->at2_res[0]);
           strcat(fields, fieldname); 
       }
	  
       for(i=1;i<sql_query->nb_at2_res;i++) {
           sprintf(fieldname,", %s.%s ", sql_query->table2, sql_query->at2_res[i]);
           strcat(fields, fieldname);
       }
     } 
   if (sql_query->tableres) {
      sprintf(qbuf,"Insert into %s select %s from %s,%s where %s.%s %s %s.%s",sql_query->tableres,fields,sql_query->table1,sql_query->table2,sql_query->table1,sql_query->at1,sql_query->op_join,sql_query->table2,sql_query->at2);
   }
   else sprintf(qbuf,"Select %s from %s,%s where %s.%s %s %s.%s",fields,sql_query->table1,sql_query->table2,sql_query->table1,sql_query->at1,sql_query->op_join,sql_query->table2,sql_query->at2);
     
      return((char*) recopie(qbuf));
 
     
}


int main(int argc,char *argv[]){
  query_list* requetes;
  query_list* curr_req;
  list_sql2* curr_op;
  
  char fich[100];
  char fich_sql[100];
  int myid =0;
  char*  qbuf;
  

  printf("etape 1\n"); 
 
  if (argc!=2) {
    printf(" usage parsertest  <fichier.sql> \n");
    return(0); 
  } 
    
  strcpy(fich_sql,argv[1]);
  strcpy(fich,"info.db");
  printf("etape 2\n");
  requetes=parser(fich_sql,fich);

  for (curr_req=requetes; curr_req!=NULL; curr_req=curr_req->next) {
    for (curr_op=curr_req->query;curr_op!=NULL;curr_op=curr_op->suivant1) {   
      printf("***********boucle********\n"); 
      if (curr_req->nbq==1) {
	trace_list_sql2(curr_op) ; 
	//curr_op->table1=concatenation(curr_op->table1,"_x");
	//if (curr_op->table2!=NULL) {
	//  curr_op->table2=concatenation(curr_op->table2,"_x");  
	//}
	qbuf=create_join_query(curr_op,myid);
	printf("-------------------------------------------\n%s\n-------------------------------------------\n",qbuf);
	free(qbuf);
      } else {
	trace_list_sql2(curr_op); 
	qbuf=create_join_query(curr_op,myid); 
	printf("-------------------------------------------\n%s\n-------------------------------------------\n",qbuf); 
	free(qbuf); 
      }
    }
  } 
  
  printf("\n***************************************************************************************************\n");
  show_sql_queries(requetes);    
  printf("\n***************************************************************************************************\n");

  return(0); 
}
